'''
快排，是原地排序，需要输入排序的上下边界，即数组下标
'''

def quick_sort(array, left, right):
    if left >= right:  #判断输入的边界是否合法，不合法则直接返回
        return
    low = left
    high = right
    key = array[low]
    while left < right:
        while left < right and array[right] > key:
            right -= 1
        array[left] = array[right]
        while left < right and array[left] <= key:
            left += 1
        array[right] = array[left]
    array[right] = key
    quick_sort(array, low, left - 1)
    quick_sort(array, left + 1, high)
    print(array)

array = [2,1,3,55,34,56,4,109,15]
quick_sort(array,0,8)
#quick_sort(array,8,0)